//  BMPx - The Dumb Music Player
//  Copyright (C) 2003-2007 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License Version 2
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LIBRARY_OPS_HH
#define BMP_LIBRARY_OPS_HH

#include <string>

#include "base-types.hh"
#include "library-types.hh"

namespace TagLib
{
  class Tag;
  namespace ID3v2
  {
    class Tag;
  }
}

namespace Bmp
{
    void
    metadata_set_common   (Track const& track, TagLib::Tag * tag);

    void
    metadata_get_id3v2    (TagLib::ID3v2::Tag * tag, DB::Row & row, std::string const& name);

    AttributeInfo
    get_attribute_info    (Bmp::AttributeId id);

} //namespace Bmp 

#endif //!BMP_LIBRARY_OPS_HH
